chiark / gitweb /
stgit.el: Add "d" for a few diff commands, similar to git.el
[stgit] / t / test-lib.sh
CommitLineData
aa9b1b9d
YD
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4# Copyright (c) 2006 Yann Dirson - tuning for stgit
5#
6
009a6a15
KH
7# Keep the original TERM for say_color
8ORIGINAL_TERM=$TERM
9
aa9b1b9d
YD
10# For repeatability, reset the environment to known value.
11LANG=C
12LC_ALL=C
13PAGER=cat
14TZ=UTC
009a6a15
KH
15TERM=dumb
16export LANG LC_ALL PAGER TERM TZ
d0105289
KH
17unset EDITOR
18unset VISUAL
009a6a15 19unset GIT_EDITOR
aa9b1b9d
YD
20unset AUTHOR_DATE
21unset AUTHOR_EMAIL
22unset AUTHOR_NAME
23unset COMMIT_AUTHOR_EMAIL
24unset COMMIT_AUTHOR_NAME
48eaeebe 25unset EMAIL
aa9b1b9d
YD
26unset GIT_ALTERNATE_OBJECT_DIRECTORIES
27unset GIT_AUTHOR_DATE
721ecd12
KH
28GIT_AUTHOR_EMAIL=author@example.com
29GIT_AUTHOR_NAME='A U Thor'
aa9b1b9d 30unset GIT_COMMITTER_DATE
721ecd12
KH
31GIT_COMMITTER_EMAIL=committer@example.com
32GIT_COMMITTER_NAME='C O Mitter'
aa9b1b9d
YD
33unset GIT_DIFF_OPTS
34unset GIT_DIR
009a6a15 35unset GIT_WORK_TREE
aa9b1b9d
YD
36unset GIT_EXTERNAL_DIFF
37unset GIT_INDEX_FILE
38unset GIT_OBJECT_DIRECTORY
39unset SHA1_FILE_DIRECTORIES
40unset SHA1_FILE_DIRECTORY
48eaeebe
YD
41GIT_MERGE_VERBOSITY=5
42export GIT_MERGE_VERBOSITY
aa9b1b9d
YD
43export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
44export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
009a6a15 45GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
48eaeebe
YD
46
47# Protect ourselves from common misconfiguration to export
48# CDPATH into the environment
49unset CDPATH
50
51case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
52 1|2|true)
53 echo "* warning: Some tests will not work if GIT_TRACE" \
54 "is set as to trace on STDERR ! *"
55 echo "* warning: Please set GIT_TRACE to something" \
56 "other than 1, 2 or true ! *"
57 ;;
58esac
aa9b1b9d
YD
59
60# Each test should start with something like this, after copyright notices:
61#
62# test_description='Description of this test...
63# This test checks if command xyzzy does the right thing...
64# '
65# . ./test-lib.sh
009a6a15
KH
66[ "x$ORIGINAL_TERM" != "xdumb" ] && (
67 TERM=$ORIGINAL_TERM &&
68 export TERM &&
69 [ -t 1 ] &&
70 tput bold >/dev/null 2>&1 &&
71 tput setaf 1 >/dev/null 2>&1 &&
72 tput sgr0 >/dev/null 2>&1
73 ) &&
74 color=t
aa9b1b9d
YD
75
76while test "$#" -ne 0
77do
78 case "$1" in
79 -d|--d|--de|--deb|--debu|--debug)
80 debug=t; shift ;;
81 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
82 immediate=t; shift ;;
83 -h|--h|--he|--hel|--help)
009a6a15 84 help=t; shift ;;
aa9b1b9d 85 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
b2017c38 86 export STGIT_DEBUG_LEVEL="-1"
aa9b1b9d 87 verbose=t; shift ;;
009a6a15
KH
88 -q|--q|--qu|--qui|--quie|--quiet)
89 quiet=t; shift ;;
90 --no-color)
91 color=; shift ;;
aa9b1b9d
YD
92 *)
93 break ;;
94 esac
95done
96
009a6a15
KH
97if test -n "$color"; then
98 say_color () {
99 (
100 TERM=$ORIGINAL_TERM
101 export TERM
102 case "$1" in
103 error) tput bold; tput setaf 1;; # bold red
104 skip) tput bold; tput setaf 2;; # bold green
105 pass) tput setaf 2;; # green
106 info) tput setaf 3;; # brown
107 *) test -n "$quiet" && return;;
108 esac
109 shift
110 echo "* $*"
111 tput sgr0
112 )
113 }
114else
115 say_color() {
116 test -z "$1" && test -n "$quiet" && return
117 shift
118 echo "* $*"
119 }
120fi
121
122error () {
123 say_color error "error: $*"
124 trap - exit
125 exit 1
126}
127
128say () {
129 say_color info "$*"
130}
131
132test "${test_description}" != "" ||
133error "Test script did not set test_description."
134
135if test "$help" = "t"
136then
137 echo "$test_description"
138 exit 0
139fi
140
aa9b1b9d
YD
141exec 5>&1
142if test "$verbose" = "t"
143then
144 exec 4>&2 3>&1
145else
146 exec 4>/dev/null 3>/dev/null
147fi
148
149test_failure=0
150test_count=0
009a6a15
KH
151test_fixed=0
152test_broken=0
153
154die () {
155 echo >&5 "FATAL: Unexpected exit with code $?"
156 exit 1
157}
aa9b1b9d 158
009a6a15 159trap 'die' exit
aa9b1b9d 160
48eaeebe
YD
161test_tick () {
162 if test -z "${test_tick+set}"
163 then
164 test_tick=1112911993
165 else
166 test_tick=$(($test_tick + 60))
167 fi
168 GIT_COMMITTER_DATE="$test_tick -0700"
169 GIT_AUTHOR_DATE="$test_tick -0700"
170 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
171}
aa9b1b9d
YD
172
173# You are not expected to call test_ok_ and test_failure_ directly, use
174# the text_expect_* functions instead.
175
176test_ok_ () {
177 test_count=$(expr "$test_count" + 1)
009a6a15 178 say_color "" " ok $test_count: $@"
aa9b1b9d
YD
179}
180
181test_failure_ () {
182 test_count=$(expr "$test_count" + 1)
183 test_failure=$(expr "$test_failure" + 1);
009a6a15 184 say_color error "FAIL $test_count: $1"
aa9b1b9d
YD
185 shift
186 echo "$@" | sed -e 's/^/ /'
187 test "$immediate" = "" || { trap - exit; exit 1; }
188}
189
009a6a15
KH
190test_known_broken_ok_ () {
191 test_count=$(expr "$test_count" + 1)
192 test_fixed=$(($test_fixed+1))
193 say_color "" " FIXED $test_count: $@"
194}
195
196test_known_broken_failure_ () {
197 test_count=$(expr "$test_count" + 1)
198 test_broken=$(($test_broken+1))
199 say_color skip " still broken $test_count: $@"
200}
aa9b1b9d
YD
201
202test_debug () {
203 test "$debug" = "" || eval "$1"
204}
205
206test_run_ () {
207 eval >&3 2>&4 "$1"
208 eval_ret="$?"
209 return 0
210}
211
48eaeebe
YD
212test_skip () {
213 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
214 this_test="$this_test.$(expr "$test_count" + 1)"
215 to_skip=
216 for skp in $GIT_SKIP_TESTS
217 do
218 case "$this_test" in
219 $skp)
220 to_skip=t
221 esac
222 done
223 case "$to_skip" in
224 t)
009a6a15 225 say_color skip >&3 "skipping test: $@"
48eaeebe 226 test_count=$(expr "$test_count" + 1)
009a6a15 227 say_color skip "skip $test_count: $1"
48eaeebe
YD
228 : true
229 ;;
230 *)
231 false
232 ;;
233 esac
234}
235
aa9b1b9d
YD
236test_expect_failure () {
237 test "$#" = 2 ||
238 error "bug in the test script: not 2 parameters to test-expect-failure"
48eaeebe 239 if ! test_skip "$@"
aa9b1b9d 240 then
009a6a15 241 say >&3 "checking known breakage: $2"
48eaeebe 242 test_run_ "$2"
009a6a15 243 if [ "$?" = 0 -a "$eval_ret" = 0 ]
48eaeebe 244 then
009a6a15 245 test_known_broken_ok_ "$1"
48eaeebe 246 else
009a6a15 247 test_known_broken_failure_ "$1"
48eaeebe 248 fi
aa9b1b9d 249 fi
48eaeebe 250 echo >&3 ""
aa9b1b9d
YD
251}
252
253test_expect_success () {
254 test "$#" = 2 ||
255 error "bug in the test script: not 2 parameters to test-expect-success"
48eaeebe 256 if ! test_skip "$@"
aa9b1b9d 257 then
48eaeebe
YD
258 say >&3 "expecting success: $2"
259 test_run_ "$2"
260 if [ "$?" = 0 -a "$eval_ret" = 0 ]
261 then
262 test_ok_ "$1"
263 else
264 test_failure_ "$@"
265 fi
aa9b1b9d 266 fi
48eaeebe 267 echo >&3 ""
aa9b1b9d
YD
268}
269
270test_expect_code () {
271 test "$#" = 3 ||
272 error "bug in the test script: not 3 parameters to test-expect-code"
48eaeebe 273 if ! test_skip "$@"
aa9b1b9d 274 then
48eaeebe
YD
275 say >&3 "expecting exit code $1: $3"
276 test_run_ "$3"
277 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
278 then
279 test_ok_ "$2"
280 else
281 test_failure_ "$@"
282 fi
aa9b1b9d 283 fi
48eaeebe 284 echo >&3 ""
aa9b1b9d
YD
285}
286
f03004e2
KH
287# When running an StGit command that should exit with an error, use
288# these instead of testing for any non-zero exit code with !.
289exit_code () {
290 expected=$1
291 shift
292 "$@"
293 test $? -eq $expected
294}
295general_error () { exit_code 1 "$@" ; }
296command_error () { exit_code 2 "$@" ; }
297conflict () { exit_code 3 "$@" ; }
298
299# Old-infrastructure commands don't exit with the proper value on
300# conflicts. But we don't want half the tests to fail because of that,
301# so use this instead of "conflict" for them.
302conflict_old () { command_error "$@" ; }
303
304# Same thing, but for other commands that StGit where we just want to
305# make sure that they fail instead of crashing.
306must_fail () {
307 "$@"
308 test $? -gt 0 -a $? -le 129
309}
310
009a6a15
KH
311# test_cmp is a helper function to compare actual and expected output.
312# You can use it like:
313#
314# test_expect_success 'foo works' '
315# echo expected >expected &&
316# foo >actual &&
317# test_cmp expected actual
318# '
319#
320# This could be written as either "cmp" or "diff -u", but:
321# - cmp's output is not nearly as easy to read as diff -u
322# - not all diff versions understand "-u"
323
324test_cmp() {
325 $GIT_TEST_CMP "$@"
326}
327
328# Most tests can use the created repository, but some may need to create more.
aa9b1b9d
YD
329# Usage: test_create_repo <directory>
330test_create_repo () {
331 test "$#" = 1 ||
332 error "bug in the test script: not 1 parameter to test-create-repo"
3fa9eb26 333 owd=$(pwd)
aa9b1b9d
YD
334 repo="$1"
335 mkdir "$repo"
336 cd "$repo" || error "Cannot setup test environment"
009a6a15
KH
337 git init >/dev/null 2>&1 || error "cannot run git init"
338 echo "empty start" | \
3fa9eb26 339 git commit-tree $(git write-tree) >.git/refs/heads/master 2>&4 || \
009a6a15
KH
340 error "cannot run git commit"
341 mv .git/hooks .git/hooks-disabled
aa9b1b9d
YD
342 cd "$owd"
343}
344
345test_done () {
346 trap - exit
009a6a15
KH
347
348 if test "$test_fixed" != 0
349 then
350 say_color pass "fixed $test_fixed known breakage(s)"
351 fi
352 if test "$test_broken" != 0
353 then
354 say_color error "still have $test_broken known breakage(s)"
355 msg="remaining $(($test_count-$test_broken)) test(s)"
356 else
357 msg="$test_count test(s)"
358 fi
aa9b1b9d
YD
359 case "$test_failure" in
360 0)
361 # We could:
362 # cd .. && rm -fr trash
363 # but that means we forbid any tests that use their own
364 # subdirectory from calling test_done without coming back
365 # to where they started from.
366 # The Makefile provided will clean this test area so
367 # we will leave things as they are.
368
009a6a15 369 say_color pass "passed all $msg"
aa9b1b9d
YD
370 exit 0 ;;
371
372 *)
009a6a15 373 say_color error "failed $test_failure among $msg"
aa9b1b9d
YD
374 exit 1 ;;
375
376 esac
377}
378
379# Test the binaries we have just built. The tests are kept in
380# t/ subdirectory and are run in trash subdirectory.
381PATH=$(pwd)/..:$PATH
29d9e8ce 382HOME=$(pwd)/trash
48eaeebe 383GIT_CONFIG=.git/config
009a6a15 384export PATH HOME GIT_CONFIG
aa9b1b9d
YD
385
386# Test repository
387test=trash
009a6a15
KH
388rm -fr "$test" || {
389 trap - exit
390 echo >&5 "FATAL: Cannot prepare test area"
391 exit 1
392}
393
aa9b1b9d
YD
394test_create_repo $test
395cd "$test"
48eaeebe
YD
396
397this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
398for skp in $GIT_SKIP_TESTS
399do
400 to_skip=
401 for skp in $GIT_SKIP_TESTS
402 do
403 case "$this_test" in
404 $skp)
405 to_skip=t
406 esac
407 done
408 case "$to_skip" in
409 t)
009a6a15
KH
410 say_color skip >&3 "skipping test $this_test altogether"
411 say_color skip "skip all tests in $this_test"
48eaeebe
YD
412 test_done
413 esac
414done